<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");

DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	DateFormatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~inca-statistics.js" 
	styles="path.css,~../css/reggie-2.css"
>
<style>

.stat-table
{
	width: 70em;
	margin-left: 2em;
	margin-bottom: 1em;
	border-collapse: collapse;
}

.stat-header
{
	border-width: 1px;
	font-weight: bold;
}

.stat-sub-header
{
	font-weight: normal;
}

.stat-table td
{
	text-align: right;
	padding: 1px 0.5em;
}

.stat-table td.count
{
	border-left-style: dotted;
	border-left-width: 1px;
}

.stat-table td.percentage
{
	text-align: left;
}

tr.stat-var 
{
	border-top-width: 1px;
	border-top-style: dotted;
}

.stat-table td.stat-var-name
{
	text-align: left;
	font-weight: bold;
}

.stat-table td.stat-var-unit
{
	text-align: left;
}

.stat-table td.stat-grp-name
{
	text-align: left;
}

.stat-table[data-check-type="simplestatistics"] .fullstatistics
{
	display: none;
}

.stat-table[data-check-type="fullstatistics"] .simplestatistics
{
	display: none;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="INCA statistics" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select INCA file</div>
		<div class="step-content">
			
			<table class="step-form">
			<tr>
				<td class="prompt">Statistics date variable</td>
				<td class="input">
					<select name="statisticsDateVar" id="statisticsDateVar"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="startDate">
						<option selected value="diagnosis" >Diagnosis date
						<option value="operation">Operation date
					</select>
				</td>
				<td class="status" id="statisticsDateVar.status"></td>
				<td class="help">
					<span id="statisticsDateVar.message" class="message"></span>
					Date variable to use for statistics time filter.
				</td>
			</tr>
			<tr>
				<td class="prompt">Statistics start date</td>
				<td class="input">
					<input type="text" name="startDate" id="startDate"
						value="20100101"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="endDate"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="startDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="startDate"
							data-date-format="yyyyMMdd"
							data-title="INCA statistics start date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="startDate.status"></td>
				<td class="help">
					<span id="startDate.message" class="message" style="display: none;"></span>
					(YYYYMMDD or MMDD) The INCA statistics start date.
				</td>
			</tr>
			<tr>
				<td class="prompt">Statistics end date</td>
				<td class="input">
					<input type="text" name="endDate" id="endDate"
						value="<%=dateFormat.format(new Date()) %>"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="cancerType"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="endDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="endDate"
							data-date-format="yyyyMMdd"
							data-title="INCA statistics end date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="endDate.status"></td>
				<td class="help">
					<span id="endDate.message" class="message" style="display: none;"></span>
					(YYYYMMDD or MMDD) The INCA statistics end date.
				</td>
			</tr>
			<tr>
				<td class="prompt">Cancer type[s]</td>
				<td class="input">
					<select name="cancerType" id="cancerType"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="incafile">
						<option selected value="">All
						<option value="invasive">Invasive cancer with or without cancer in situ
						<option value="insitu">Cancer in situ only
					</select>
				</td>
				<td class="status" id="cancerType.status"></td>
				<td class="help">
					<span id="cancerType.message" class="message"></span>
					Cancer type filter. Option "All" is equal to not applying a cancer type filter. Note that an entry may be labeled both "Invasive" and "In situ".
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">INCA file</td>
				<td class="input">
					<table style="width: 100%;">
					<tr>
					<td>
						<input type="file" name="incafile" id="incafile" class="required" style="width: 95%;" accept=".csv,.tsv">
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="incafile.status"></td>
				<td class="help"><span id="incafile.message" class="message"></span>
					Select INCA file to be used for INCA statistics. The file should be a text file in tab-separated format, where the first line contains column names.
				</td>
			</tr>
			</table>
		</div>
	</div>

	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">INCA file check</div>
		<div class="step-content">

			<table class="step-form" id="statisticscheck">
			<tbody>
				<tr>
					<td class="prompt">File</td>
					<td class="input" id="filename"></td>
					<td class="status" id="filename.status"></td>
					<td class="help"></td>
				</tr>
				<tr>
					<td class="prompt">Is follow-up file</td>
					<td class="input" id="isFollowUp"></td>
					<td class="status" id="isFollowUp.status"></td>
					<td class="help">
					</td>
				</tr>
				<tr>
					<td class="prompt">Header columns</td>
					<td class="input" id="headerCount"></td>
					<td class="status" id="headerCount.status"></td>
					<td class="help"></td>
				</tr>
			</tbody>
			
			<tbody class="info-section">
				<tr>
					<td class="prompt">Required but missing</td>
					<td class="info" id="headerMissing"></td>
					<td class="status" id="headerMissing.status"></td>
					<td class="help"><span id="headerMissing.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Missing INCA annotations</td>
					<td class="info" id="headerMissingAnnotationTypes"></td>
					<td class="status" id="headerMissingAnnotationTypes.status"></td>
					<td class="help"><span id="headerMissingAnnotationTypes.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Duplicates</td>
					<td class="info" id="headerDuplicates"></td>
					<td class="status" id="headerDuplicates.status"></td>
					<td class="help"><span id="headerDuplicates.message"></span></td>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<td class="prompt">Data lines</td>
					<td class="input" id="lineCount"></td>
					<td class="status" id="lineCount.status"></td>
					<td class="help"><span id="lineCount.message"></span></td>
				</tr>
			</tbody>
			<tbody class="info-section">
				<tr>
					<td class="prompt">Lines that can be used</td>
					<td class="input" id="statisticsLineCount"></td>
					<td class="status" id="statisticsLineCount.status"></td>
					<td class="help"><span id="statisticsLineCount.message"></span></td>
				</tr>
				<tr>
					<td class="prompt">Excluded lines</td>
					<td class="info" id="totalExcluded"></td>
					<td class="status" id="totalExcluded.status"></td>
					<td class="help"><span id="totalExcluded.message"></span></td>
				</tr>
				<tr id="tooManyColumns.row">
					<td class="subprompt">- too many columns</td>
					<td class="info" id="tooManyColumns"></td>
					<td class="status" id="tooManyColumns.status"></td>
					<td class="help"><span id="tooManyColumns.message"></span></td>
				</tr>
				<tr id="tooFewColumns.row">
					<td class="subprompt">- too few columns</td>
					<td class="info" id="tooFewColumns"></td>
					<td class="status" id="tooFewColumns.status"></td>
					<td class="help"><span id="tooFewColumns.message"></span></td>
				</tr>
				<tr id="missingLaterality.row">
					<td class="subprompt">- missing or invalid laterality</td>
					<td class="info" id="missingLaterality"></td>
					<td class="status" id="missingLaterality.status"></td>
					<td class="help"><span id="missingLaterality.message"></span></td>
				</tr>
				<tr id="duplicateLaterality.row">
					<td class="subprompt">- duplicate laterality</td>
					<td class="info" id="duplicateLaterality"></td>
					<td class="status" id="duplicateLaterality.status"></td>
					<td class="help"><span id="duplicateLaterality.message"></span></td>
				</tr>
				<tr id="invalidDataValue.row">
					<td class="subprompt">- invalid data value</td>
					<td class="info" id="invalidDataValue"></td>
					<td class="status" id="invalidDataValue.status"></td>
					<td class="help"><span id="invalidDataValue.message"></span></td>
				</tr>
				<tr id="filteredByDate.row">
					<td class="subprompt">- filtered by date</td>
					<td class="info" id="filteredByDate"></td>
					<td class="status" id="filteredByDate.status"></td>
					<td class="help"><span id="filteredByDate.message"></span></td>
				</tr>
				<tr id="filteredByCancerType.row">
					<td class="subprompt">- filtered by cancer type</td>
					<td class="info" id="filteredByCancerType"></td>
					<td class="status" id="filteredByCancerType.status"></td>
					<td class="help"><span id="filteredByCancerType.message"></span></td>
				</tr>
			</tbody>
			</table>
		</div>
	</div>

	<div id="wizard-status"></div>
	<div id="wizard-progress"></div>

	<table class="stat-table" id="stat-table" style="display: none;">
		<tbody class="stat-header bg-filled-100">
		<tr>
			<td style="text-align:left;">Variable</td>
			<td style="text-align:left;">Value</td>
			<td style="text-align:center;" colspan="2">Total</td>
			<td style="text-align:center;" class="fullstatistics" colspan="2">Accrued</td>
			<td style="text-align:center;" colspan="2">Accrued</td>
			<td style="text-align:center;" colspan="2">NotAccrued</td>
		</tr>
		<tr class="fullstatistics stat-sub-header">
			<td></td>
			<td></td>
			<td style="text-align:center;" colspan="2"></td>
			<td style="text-align:center;" colspan="2">specimen</td>
			<td style="text-align:center;" colspan="2">no specimen</td>
			<td style="text-align:center;" colspan="2"></td>
		</tr>
		</tbody>
		<tbody id="stat-data" style="border-width: 1px;"></tbody>
		<tbody>
		<tr>
			<td colspan="10" style="text-align: left;">Percentage values are not including N/A entries.</td>
		</tr>
		</tbody>
	</table>

	<div id="reportfiles" style="margin-left: 2em; margin-top: 0.5em;">
		<base:icon id="downloadreportfile" style="display: none;" 
			image="<%=home+"/images/download.png"%>"
			data-report-type="statistics"
			>Download report file</base:icon>
		<base:icon id="downloadoutputfile" style="display: none;" 
			image="<%=home+"/images/download.png"%>"
			data-report-type="statistics_csv"
			>Download output CSV file</base:icon>
	</div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td><base:button id="simplestatistics" title="Simple statistics" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="fullstatistics" title="Full statistics" image="<%=home+"/images/gonext.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	<div id="explainFileCheck" class="messagecontainer note" style="margin-left: 2em; padding: 0.5em;width: 55em;">
		<ul>
		<li style="margin-bottom: 0.25em;"><b>Simple statistics</b>: Checks that the INCA data file is well formed, 
			that required information is present and that data values are valid. Statistics is calculated based
			only on the information that is in the file. This is typically very quick and 
			should only take a few seconds to complete.
		<li><b>Full statistics</b>: Statistics is calculated based on both information that is 
			in the file and in the database. 
		</ul>
	</div>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>